#
#---------------------------------------------------
#
# kmeans_silhouette v.0.0.2 - 30 / 01 / 2013
# Authors:
# Alessio Papini - Department of Plant Biology University of Florence Italy, Via La Pira, 4 Firenze, mail alpapiniATunifi.it
# Ugo Santosuosso - Department of Anatomny, Istology and Forensic Medicine, Largo Brambilla, 1 Firenze, mail ugoATunifi.it
# 
# Implements:
#
#---------------------------------------------------
#
# importo le librerie 
#
import os, sys
import math
import numpy
import csv
#from pylab import plot,show
from pylab import *
from numpy import vstack,array
from numpy.random import rand
from scipy.cluster.vq import kmeans,vq,whiten
from numpy import *
#
#
#
#import numpy as np
from scipy.cluster.vq import kmeans2
from scipy.spatial.distance import pdist, squareform
#from scikits.learn import datasets
#import matplotlib.pyplot as plt
#import matplotlib.pyplot
from matplotlib import cm
#
# -----------------------------------------------------
#
def silhouette(X, cIDX):
    """
    Computes the silhouette score for each instance of a clustered dataset,
    which is defined as:
        s(i) = (b(i)-a(i)) / max{a(i),b(i)}
    with:
        -1 <= s(i) <= 1

    Args:
        X    : A M-by-N array of M observations in N dimensions
        cIDX : array of len M containing cluster indices (starting from zero)

    Returns:
        s    : silhouette value of each observation
    """

    N = X.shape[0]              # number of instances
    K = len(unique(cIDX))    # number of clusters

    # compute pairwise distance matrix
    D = squareform(pdist(X))

    # indices belonging to each cluster
    kIndices = [flatnonzero(cIDX==k) for k in range(K)]

    # compute a,b,s for each instance
    a = zeros(N)
    b = zeros(N)
    for i in range(N):
        # instances in same cluster other than instance itself
        a[i] = mean( [D[i][ind] for ind in kIndices[cIDX[i]] if ind!=i] )
        # instances in other clusters, one cluster at a time
        b[i] = min( [mean(D[i][ind]) 
                        for k,ind in enumerate(kIndices) if cIDX[i]!=k] )
    s = (b-a)/maximum(a,b)

    return s
#
# -----------------------------------------------------
#
NUM_ARGS=3
nome=sys.argv[0]
Graph=sys.argv[3]
if (len(sys.argv) < NUM_ARGS ):
#
 print" ------------------------------- "
 print" "
 print" ------ "+nome+" --------"
 print" " 
 print" The coordinates must be provided in a simple text file in csv format,"
 print" with x coordinates in the first column and y in the second column."
 print" Values on a row separated by a comma (0,0) is upper left corner of the image"
 print" How the program works: insert parameters following the program name: that is "
 print" "
 print" python "+nome+" coordinates.csv Number_of_cluster Graph"
 print" " 
 print" Graph = G/N "
 print"         G = present a Graphical rapresentation of clusters and centroids" 
 print"         N = No Graph (default)" 
 print" "
 print" No path specifications = current directory"
 print" "
 print" ------------------------------- "
 sys.exit (0)
#----------------
# input the coordinates in csv format with comma as separator
#
i2csv=sys.argv[1]
#
# input the number of clusters as an integer
#
nclust=int(sys.argv[2])
ccsv = open(i2csv, 'r')
#
# separation of first line to x coordinates and second line to y coordinates and transformation of string data in lists (of strings of the numbers)
#
crimescsvx=[]
crimescsvy=[]
pesi=[]
with open(i2csv, 'rb') as fcsv:
  reader = csv.reader(fcsv)
  for row in reader:
   num, acsv, bcsv, peso= row
   crimescsvx.append(acsv)
   crimescsvy.append(bcsv)
   pesi.append(peso)
   # end for row ---
# end with ---
#
# ora le devo trasfromare in integer
# inoltre posso contare il numero di elementi presenti nel csv: questo metodo scambia inoltre righe con colonne
#
NB_CRIMEScsv=len(crimescsvx)
NB_CRIMEScsvbis = len(crimescsvy)
if NB_CRIMEScsv != NB_CRIMEScsvbis:
 print('The number of x coordinates is different from the number of y coordinates!! Please check the data')
crime_x=[]
crime_y=[]
allcoord=zeros( (NB_CRIMEScsv,2) )
#
# riempio il vettore delle coordinate
#
for it in range (NB_CRIMEScsv):
  allcoord[it][0]=(int(crimescsvx[it]))
  allcoord[it][1]=(int(crimescsvy[it]))
#------------------------------------------------------------  
#
# Cluster generation - it builds the two arrays with results
#
#------------------------------------------------------------
#centroids,_ = kmeans(allcoord,nclust)
#idx,_ = vq(allcoord,centroids)
#----------------------------------
#C, cIDX = kmeans2(X, K)
#s = silhouette(X, cIDX)
# 
# X corrisponde a allcoord
# K corrisponde a nclust
# cIDX corrisponde a idx
#
#----------------------------------
centroids,_ = kmeans(allcoord, int(nclust))
idx,_ = vq(allcoord,centroids)
s = silhouette(allcoord, idx)
X=allcoord
K= nclust
cIDX=idx
#
# Output di debug
#
if (Graph=="G"):
 for i in range (NB_CRIMEScsv):
  print "Coordinate ", allcoord[i,0], allcoord[i,1], idx[i]
 for i in range (nclust):
  print "Centroidi ", centroids[i,0],centroids[i,1]
  #
# endif
#
# Scrive i risultati
#
for i in range (nclust):
#
# genero i nomi dei file
#
  nome="cluster"+str(i+1)+"di"+str(nclust)+i2csv+".txt"
#
# apro/genero i file
#
  salva=open(nome,"w")
#
# ci scrivo i dati num,X,Y,pesi
#
  for j in range (NB_CRIMEScsv):
   if (idx[j]== i):
    # scrivo i risultati nel file...
     salva.write(str(j)+","+str(int(allcoord[j,0]))+","+str(int(allcoord[j,1]))+","+str(int(pesi[j]))+"\n")
    #endif
   #endfor
#
# li chiudo
#
  salva.close()
#ENDFOR 
#
# salvo il file dei centroidi
#
nome="centroids"+str(nclust)+"cluster"+i2csv+".txt"
salva=open(nome,"w")
for i in range (nclust):
 salva.write(str(int(centroids[i,0]))+","+str(int(centroids[i,1]))+"\n")
#
salva.close()
#
#the up instructions to reset the files that will contain the final clusters data
#i save here the coordinates of the centroids in the two files centroidsx.txt and centroidsy.txt
#
# i try with three clusters
# some plotting using numpy's logical indexing
#
if (Graph=="G"):
 #for i in range (nclust):
  # plot (allcoord[idx==i,0],allcoord[idx==i,1],'o')
   #
   # end for - plot
   #
 #plot(centroids[:,0],centroids[:,1],'s',markersize=6)
 #show()
 order = lexsort((-s,cIDX))
 indices = [flatnonzero(cIDX[order]==k) for k in range(K)]
 print " "
 for k in range(K):
 	print "k=",k," Sil",s[k],"order =", order[k]," indices= ", indices[k]
 print ""
 ytick = [(max(ind)+min(ind))/2 for ind in indices]
 ytickLabels = ["%d" % x for x in range(K)]
 cmap = cm.jet( linspace(0,1,K) ).tolist()
 clr = [cmap[i] for i in cIDX[order]]
 fig = figure()
 ax = fig.add_subplot(111)
 ax.barh(range(X.shape[0]), s[order], height=1.0, edgecolor='none', color=clr)
 ax.set_ylim(ax.get_ylim()[::-1])
 yticks(ytick, ytickLabels)
 xlabel('Silhouette Value')
 ylabel('Cluster')
 show()
#
# le istruzioni per graficare la silhouette vanno messe qui
#

#
#
print""
print" End of program"
print""
